"""Unit tests for charm actions."""

import os
import sys
import unittest.mock as mock

action_path = os.path.join(os.path.dirname(__file__), "..", "..", "actions")
sys.path.append(action_path)
import actions  # NOQA


@mock.patch("libsudopair.SudoPairHelper")
@mock.patch("actions.action_set")
@mock.patch("actions.status_set")
def test_remove_action(status_set, action_set, sudo_pair_helper):
    """Verify remove action."""
    actions.remove()
    msg = "Successfully removed sudo-pair config and binaries"
    action_set.assert_called_with({"message": msg})
    status_set.assert_called_with("active", msg)
    sudo_pair_helper().deconfigure.assert_called()
